const { resolve } = require("./utils");
const mainInit = require("./mainInit");
const { injectImport, injectFunctionUse } = require("./useMainInject");

/**
 * 在 main.[t|j]s 中进行注入，如果不存，则创建并注入
 * @param {api} api
 * @param {string} importFrom: import xxx from '\<importFrom\>';
 * @param {string} defaultImport: import \<defaultImport\> from '\<importFrom\>';
 * @param {string[]} importList: import \<defaultImport\>, { ...\<importList\> } from '\<importFrom\>';
 * @param {string} usedName: app.use
 */
module.exports = (api, importFrom, defaultImport, importList, usedName) => {
  mainInit(api);

  api.transformScript(api.entryFile, injectImport, {
    from: importFrom,
    default: defaultImport,
    importList,
  });
  api.transformScript(api.entryFile, injectFunctionUse, {
    fnName: "render",
    usedName,
  });
};
